# Step 1: Create a new project called tb
project_new tb -overwrite
project_open tb
# Step 2: Project settings: 
#   a. Choose the type of FPGA
set_global_assignment -name FAMILY Cyclone
set_global_assignment -name DEVICE EP1C20F400C7
#   b. Any pins which aren't otherwise defined should be inputs.
set_global_assignment -name RESERVE_ALL_UNUSED_PINS "AS INPUT TRI-STATED"

#   c.  Declare the top-level file (well, the only file):
set_global_assignment -name VERILOG_FILE top.v
set_global_assignment -name TOP_LEVEL_ENTITY top

# Step 3: Set pin assignments. This is where the top-level ports of the testbench
#  design are mapped to actual physical FPGA pins. 
set_location_assignment PIN_K5  -to clk
set_location_assignment PIN_C4  -to reset_n
set_location_assignment PIN_T15 -to ir_in
# set_location_assignment PIN_E14 -to out[0]
# set_location_assignment PIN_E13 -to out[1]
# set_location_assignment PIN_C14 -to out[2]
# set_location_assignment PIN_D14 -to out[3]
# set_location_assignment PIN_E12 -to out[4]
# set_location_assignment PIN_F12 -to out[5]
# set_location_assignment PIN_B3  -to out[6]
# set_location_assignment PIN_B14 -to out[7]

# set_location_assignment PIN_W4 -to sw_in[3]
# set_location_assignment PIN_V4 -to sw_in[2]
# set_location_assignment PIN_Y4 -to sw_in[1]
# set_location_assignment PIN_W3 -to sw_in[0]

#     
#    -a
#   f  b
#   |-g|
#   e  c
#    -d
#         dp

#     
#    -7
#   2  6
#   |-1|
#   3  5
#    -4
#         0

# Two seven-segment digits, ss1 (left) and ss0 (right)
set_location_assignment PIN_T5 -to ss1[7]
set_location_assignment PIN_U5 -to ss1[6]
set_location_assignment PIN_V5 -to ss1[5]
set_location_assignment PIN_W5 -to ss1[4]
set_location_assignment PIN_T6 -to ss1[3]
set_location_assignment PIN_T7 -to ss1[2]
set_location_assignment PIN_W6 -to ss1[1]
set_location_assignment PIN_Y6 -to ss1[0]

set_location_assignment PIN_U6 -to ss0[7]
set_location_assignment PIN_V6 -to ss0[6]
set_location_assignment PIN_W7 -to ss0[5]
set_location_assignment PIN_Y7 -to ss0[4]
set_location_assignment PIN_R7 -to ss0[3]
set_location_assignment PIN_T8 -to ss0[2]
set_location_assignment PIN_V7 -to ss0[1]
set_location_assignment PIN_U7 -to ss0[0]

# Step 4.  That's all!
project_close
