module top(
  clk,
  reset_n,
  ir_in,
  
  ss1,
  ss0
);
  input clk;
  input reset_n;
  input ir_in;
  
  output [7:0] ss1;
  output [7:0] ss0;

  // These signals are asynchronous to the system clock.  Synchronize them.
  reg d1_ir_in;
  reg ir;
  always @(posedge clk or negedge reset_n) begin
    if (!reset_n) begin
       d1_ir_in <= 1'b1;
       ir <= 1'b1;
    end
    else begin
      d1_ir_in <= ir_in;
      ir <= d1_ir_in;
    end
  end

  sys the_sys(
    .clk (clk),
    .reset_n (reset_n),
    .ir (ir),
    .ss1 (ss1),
    .ss0 (ss0)
  );

endmodule
