//Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

//vj_name => vj
//interface_widths => 1,6,20,8,1
//interface_opcodes => 
//do_signaltap => 0
//name => vj_rw
//interface_types => r,r,r,w,r
//interface_names => rdempty,rdusedw,readdata,outdata,rdfull
//ir_width_user_override => 
module vj_rw_module (
                      // inputs:
                       rdempty,
                       rdfull,
                       rdusedw,
                       readdata,

                      // outputs:
                       ack_outdata,
                       ack_rdempty,
                       ack_rdfull,
                       ack_rdusedw,
                       ack_readdata,
                       outdata,
                       vj_clk
                    )
;

  output           ack_outdata;
  output           ack_rdempty;
  output           ack_rdfull;
  output           ack_rdusedw;
  output           ack_readdata;
  output  [  7: 0] outdata;
  output           vj_clk;
  input            rdempty;
  input            rdfull;
  input   [  5: 0] rdusedw;
  input   [ 19: 0] readdata;

  wire             ack_outdata;
  wire             ack_rdempty;
  wire             ack_rdfull;
  wire             ack_rdusedw;
  wire             ack_readdata;
  reg              bypass_reg;
  wire             cdr;
  wire             cir;
  wire             e1dr;
  wire             e2dr;
  wire    [  2: 0] ir_in;
  wire    [  2: 0] ir_out;
  reg     [  7: 0] outdata;
  wire             pdr;
  reg     [  5: 0] rdusedw_tmp_reg;
  reg     [ 19: 0] readdata_tmp_reg;
  wire             sdr;
  wire             select_outdata;
  wire             select_rdempty;
  wire             select_rdfull;
  wire             select_rdusedw;
  wire             select_readdata;
  wire             tck;
  wire             tdi;
  wire             tdo;
  wire             udr;
  wire             uir;
  wire             vj_clk;
  assign vj_clk = tck;
  vj vj_inst
    (
      .ir_in (ir_in),
      .ir_out (ir_out),
      .tck (tck),
      .tdi (tdi),
      .tdo (tdo),
      .virtual_state_cdr (cdr),
      .virtual_state_cir (cir),
      .virtual_state_e1dr (e1dr),
      .virtual_state_e2dr (e2dr),
      .virtual_state_pdr (pdr),
      .virtual_state_sdr (sdr),
      .virtual_state_udr (udr),
      .virtual_state_uir (uir)
    );


  assign ir_out = 3'b000;
  always @(posedge tck)
    begin
      bypass_reg <= tdi;
    end


  assign select_outdata = ir_in == 3'b011;
  assign select_rdempty = ir_in == 3'b000;
  assign select_rdfull = ir_in == 3'b100;
  assign select_rdusedw = ir_in == 3'b001;
  assign select_readdata = ir_in == 3'b010;
  always @(posedge tck)
    begin
      if (select_outdata & sdr)
          outdata <= {tdi,
                    outdata[7 : 1]};

    end


  assign ack_outdata = e1dr & select_outdata;
  assign ack_rdempty = e1dr & select_rdempty;
  assign ack_rdfull = e1dr & select_rdfull;
  always @(posedge tck)
    begin
      if (cdr | sdr)
          rdusedw_tmp_reg <= cdr ? rdusedw : {1'b0,
                    rdusedw_tmp_reg[5 : 1]};

    end


  assign ack_rdusedw = e1dr & select_rdusedw;
  always @(posedge tck)
    begin
      if (cdr | sdr)
          readdata_tmp_reg <= cdr ? readdata : {1'b0,
                    readdata_tmp_reg[19 : 1]};

    end


  assign ack_readdata = e1dr & select_readdata;
  assign tdo = (select_rdempty)? rdempty :
    (select_rdfull)? rdfull :
    (select_rdusedw)? rdusedw_tmp_reg[0] :
    (select_readdata)? readdata_tmp_reg[0] :
    bypass_reg;


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module vj_rw (
               // inputs:
                rdempty,
                rdfull,
                rdusedw,
                readdata,

               // outputs:
                ack_outdata,
                ack_rdempty,
                ack_rdfull,
                ack_rdusedw,
                ack_readdata,
                outdata,
                vj_clk
             )
;

  output           ack_outdata;
  output           ack_rdempty;
  output           ack_rdfull;
  output           ack_rdusedw;
  output           ack_readdata;
  output  [  7: 0] outdata;
  output           vj_clk;
  input            rdempty;
  input            rdfull;
  input   [  5: 0] rdusedw;
  input   [ 19: 0] readdata;

  wire             ack_outdata;
  wire             ack_rdempty;
  wire             ack_rdfull;
  wire             ack_rdusedw;
  wire             ack_readdata;
  wire    [  7: 0] outdata;
  wire             vj_clk;
  vj_rw_module the_vj_rw_module
    (
      .ack_outdata  (ack_outdata),
      .ack_rdempty  (ack_rdempty),
      .ack_rdfull   (ack_rdfull),
      .ack_rdusedw  (ack_rdusedw),
      .ack_readdata (ack_readdata),
      .outdata      (outdata),
      .rdempty      (rdempty),
      .rdfull       (rdfull),
      .rdusedw      (rdusedw),
      .readdata     (readdata),
      .vj_clk       (vj_clk)
    );


endmodule

